/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

listsrc = window.arguments[0];
NeedText = window.arguments[1];
var prmtbox, plbl, pbox;
window.opener.top.cancel = true;

function listloader(){
	window.setTimeout('MakeLists();', 0);
}

function MakeLists(){
try{
  rs = document.getElementById("rows");
  for (i in listsrc){
    if (listsrc[i].list){
			//vbox = document.createElement('vbox');
			row = document.createElement('row');
			//row.setAttribute("flex", "1");
    	lbl = document.createElement('label');
    	if (listsrc[i].grouptitle) {lbl.setAttribute("value", listsrc[i].grouptitle+":")}else{lbl.setAttribute("value", listsrc[i].name+":")};
      row.appendChild(lbl);
      rs.appendChild(row);
      
      row = document.createElement('row');
      row.setAttribute("id", "hbox_"+i);
    	lst = document.createElement('menulist');
      lst.setAttribute("id", "list_"+i);
      lst.setAttribute("oncommand", "list_onsel('"+i+"', this)");
      pp = document.createElement('menupopup');
      item = document.createElement('menuitem');
      if (listsrc[i].def.label) {item.setAttribute("label", listsrc[i].def.label)}else{item.setAttribute("label", listsrc[i].def.value)};
      item.setAttribute("value", listsrc[i].def.value);
      pp.appendChild(item);

    	for (v in listsrc[i].list){
        if (listsrc[i].def.priority != v) {
          item = document.createElement('menuitem');
          if (listsrc[i].list[v].label){item.setAttribute("label", listsrc[i].list[v].label)}else{item.setAttribute("label", listsrc[i].list[v].value)};
          item.setAttribute("value", listsrc[i].list[v].value);
          pp.appendChild(item);
        }
    	}
      tbox = document.createElement('textbox');
      tbox.setAttribute("id", i);
      lst.appendChild(pp);
      row.appendChild(lst);
      row.appendChild(tbox);
      rs.appendChild(row);
      setval(i, listsrc[i].value);
    } else {
      if (listsrc[i].value.search(/\[:\w+\]/gi)!=-1){
			row = document.createElement('row');
    	lbl = document.createElement('label');
    	if (listsrc[i].label) {lbl.setAttribute("value", listsrc[i].label+":")}else{lbl.setAttribute("value", listsrc[i].name+":")};
      row.appendChild(lbl);
      tbox = document.createElement('textbox');
      tbox.setAttribute("id", i);
      row.appendChild(tbox);
      rs.appendChild(row);
      setval(i, listsrc[i].value);
      }
    }
  }
	window.sizeToContent();
  var x   = window.opener.screenX + window.opener.outerWidth/2;
  var y   = window.opener.screenY + window.opener.outerHeight/2;
  window.screenX = Math.max(0, x - window.outerWidth/2);
  window.screenY = Math.max(0, y - window.outerHeight/2);
}catch(er){cqerr(er, "MakeLists sub")}
}

function setval(id, val){
  tbox = document.getElementById(id);
  if (val == "[:prompt]"){
    tbox.value = "";
    tbox.readonly = false;
  } else if (val == "[:text]"){
    tbox.value = "";
    tbox.readonly = false;
  } else if (val == "[:url]"){
    tbox.value = window.opener.top.PageURL;
    tbox.readonly = false;
  } else if (val == "[:host]"){
    tbox.value = window.opener.top.PageHost;
    tbox.readonly = false;
  } else if (val == "[:selection]"){
    tbox.value = window.opener.top.PageSelection;
    tbox.readonly = false;
  }else{
    tbox.value = val;
    tbox.readonly = true;
  }
}

function list_onsel(id, list){
  setval(id, list.value);
}


function onOk(){
try{
//  for (each in PrmptHash){
//    alert(each + "  ==  " + PrmptHash[each]);
//  }
	window.opener.top.cancel = false;
//	act = "";
//	amp = "";
//  for (i in listsrc){
//    if (listsrc[i].list){
//			lst = document.getElementById(i);
//			act += amp + listsrc[i].def.name + "=" + lst.selectedItem.value;
//    }else{
//    	act += amp + listsrc[i].def.name + "=" + listsrc[i].def.value;
//    }
//  amp = "&";
//  }

  for (i in listsrc){
    if (listsrc[i].list){
			lst = document.getElementById("list_"+i);
			QueryHash[listsrc[i].def.name] = lst.selectedItem.value;
    }else{
    	QueryHash[listsrc[i].def.name] = listsrc[i].def.value;
    }
  }

	tbs = document.getElementsByTagName("textbox");
	for (i=0; i<tbs.length;i++) {
	  QueryHash[tbs[i].id] = tbs[i].value;
	}

	window.opener.top.QueryHash = QueryHash;
  //if (NeedText) window.opener.top.PageSelection = document.getElementById("seltxt").value;
	if (prmtbox) window.opener.top.PromptText = prmtbox.value;
}catch(err){cqerr(err, "")}
}
